import {
    declareTrial
  } from "~/config/Declare/Common/declareTrialCopy";
import Request from '~/utils/request';
import Utils from "~/utils";
  
export default {
    methods: {
        hasDeclare() {
            if (this.model.declareMod.safeDeclWay == '1' || this.model.declareMod.safeDeclWay == '2' || this.model.declareMod.rcpmisDeclWay == '1') {
              return true
            } else {
              return false
            }
          },

        updateDeclare() {
            let request = {
            head: {
                txCode: this.declareParams.txCode,
            },
            body: {
                declare: this.getDeclMap(),
                bizData: this.model
            }
            }
            if (this.declareParams.txCode === '040101') {
            return declareTrial(request, this.OrtModel, this.DrtModel, this.ExpnModel)
            } else if (this.declareParams.txCode === '040201' || this.declareParams.txCode === '040203') {
            return declareTrial(request, this.OinModel, this.DinModel, this.IncomeModel)
            } else if (this.declareParams.txCode === '030301') {
            return declareTrial(request, this.ExtguarsModel, this.ExtguarbModel, this.GuaenrInfoModel)
            } else if (this.declareParams.txCode === '020314') {
            return declareTrial(request, this.OpyModel, this.DpyModel, this.ExpnModel)
            } else if (this.declareParams.txCode === '050205') {
            return declareTrial(request, this.OinModel, this.DinModel, this.IncomeModel)
            } else if (this.declareParams.txCode === '050105') {
            return declareTrial(request, this.OpyModel, this.DpyModel, this.ExpnModel)
            }else if (this.declareParams.txCode === '020412') {
            //出口信用证收汇
            return declareTrial(request, this.OinModel, this.DinModel, this.IncomeModel)
            }else if(this.declareParams.txCode === '050201'){
            return declareTrial(request, this.BankDocSetModel)
            }else if(this.declareParams.txCode === '050101'){
            return declareTrial(request, this.BankDocSetModel)
            }         
        },

        getDeclMap() {
            if (this.model.declareMod && this.model.declareMod.safeDeclType && this.model.declareMod.safeDeclType.length > 0 && this.model.declareMod.rcpmisDeclType && this.model.declareMod.rcpmisDeclType.length > 0) {
            return {
                'declType': [...this.model.declareMod.safeDeclType, ...this.model.declareMod.rcpmisDeclType],
            }
            } else if (this.model.declareMod && this.model.declareMod.safeDeclType && this.model.declareMod.safeDeclType.length > 0) {
            return {
                'declType': [...this.model.declareMod.safeDeclType],
            }
            } else if (this.model.declareMod && this.model.declareMod.rcpmisDeclType && this.model.declareMod.rcpmisDeclType.length > 0) {
            return {
                'declType': [...this.model.declareMod.rcpmisDeclType],
            }
            }
        },

        updateDeclareModel(declare) {
            if (!declare) return
            this.delcareOldModel = JSON.parse(JSON.stringify(declare))           
            this.updateDeclareMod(this.model, declare);
            if(declare.trdtyp == '040101'){
            if(declare && declare.decmstOrtVo){
                this.OrtModel.decmstOrtBaseVo = declare.decmstOrtVo.decmstOrtBaseVo
                this.OrtModel.decdtlOrtDeclrVo = declare.decmstOrtVo.decdtlOrtDeclrVo
                this.OrtModel.decdtlOrtManageVo = declare.decmstOrtVo.decdtlOrtManageVo
                let market= this.OrtModel.decmstOrtBaseVo.marketorg;
                Request.get("/v1/pm/instManage/queryDownInstById/" + market).then(rtn => {
                if (rtn.code == "000000") {
                this.OrtModel.decmstOrtBaseVo.declareorg = rtn.data[0].finInstNo;
                }
                });
            }
            if(declare && declare.decmstDrtVo){
                this.DrtModel.decmstDrtBaseVo = declare.decmstDrtVo.decmstDrtBaseVo
                this.DrtModel.decdtlDrtManageVo = declare.decmstDrtVo.decdtlDrtManageVo
                let market= this.DrtModel.decmstDrtBaseVo.marketorg;
                Request.get("/v1/pm/instManage/queryDownInstById/" + market).then(rtn => {
                if (rtn.code == "000000") {
                this.DrtModel.decmstDrtBaseVo.declareorg = rtn.data[0].finInstNo;
                }
                });
            }
            if (declare && declare.decmstExpnVo) {
                this.ExpnModel = declare.decmstExpnVo
            }
            }
            
            this.$refs['declare_oin'] && this.$refs['declare_oin'].updateModel(declare)
            this.$refs['declare_din'] && this.$refs['declare_din'].updateModel(declare)
            if (declare && declare.decmstIncomeVo) {
            this.IncomeModel = declare.decmstIncomeVo
            }
            this.$refs['declare_extGuarSign'] && this.$refs['declare_extGuarSign'].updateModel(declare)
            this.$refs['declare_extGuarBal'] && this.$refs['declare_extGuarBal'].updateModel(declare)
            if (declare && declare.decmstGuaenrInfoVo) {
            this.GuaenrInfoModel = declare.decmstGuaenrInfoVo
            }
            this.$refs['declare_opy'] && this.$refs['declare_opy'].updateModel(declare)
            this.$refs['declare_dpy'] && this.$refs['declare_dpy'].updateModel(declare)
            if (declare && declare.decmstbankdocsetVo) {
            this.BankDocSetModel = declare.decmstbankdocsetVo
            }
        },

        //将declare中变化的非申报model进行反显  model(当前业务model)/declare(业务大字段)
        updateDeclareMod(model, declare) {
            model.declareMod.safeDeclWay = declare.safeDeclWay;
            model.declareMod.rcpmisDeclWay = declare.rcpmisDeclWay;
            model.declareMod.safeDeclType = declare.safeDeclType;
            model.declareMod.rcpmisDeclType = declare.rcpmisDeclType;
        },

        genDeclareData(body) {
            body.declare = {}
            body.declare.safeDeclWay = this.model.declareMod.safeDeclWay;
            body.declare.rcpmisDeclWay = this.model.declareMod.rcpmisDeclWay;
            body.declare.safeDeclType = this.model.declareMod.safeDeclType;
            body.declare.rcpmisDeclType = this.model.declareMod.rcpmisDeclType;
            body.declare.busNo = this.declareParams.busiNo;
            body.declare.trdtyp = this.declareParams.txCode;
            body.declare.trdid = this.serialNo || this.$route.query.routeParams.txSriNo || '';
            if (this.declareParams.txCode == '040101') {
                if (this.OrtModel && this.model.declareMod.safeDeclType == 'DecmstOrt') {
                body.declare.decmstOrtVo = {
                    decmstOrtBaseVo: this.OrtModel.decmstOrtBaseVo,
                    decdtlOrtDeclrVo: this.OrtModel.decdtlOrtDeclrVo,
                    decdtlOrtManageVo: this.OrtModel.decdtlOrtManageVo,
                }
                }
                if (this.DrtModel && this.model.declareMod.safeDeclType == 'DecmstDrt') {
                body.declare.decmstDrtVo = {
                    decmstDrtBaseVo: this.DrtModel.decmstDrtBaseVo,
                    decdtlDrtManageVo: this.DrtModel.decdtlDrtManageVo
                }
                }
                if (this.ExpnModel && this.model.declareMod.rcpmisDeclWay == '1') {
                body.declare.decmstExpnVo = this.ExpnModel
                }
                if (this.OrtModel && this.OrtModel.decmstOrtBaseVo.custype) {
                body.declare.cusType = this.OrtModel.decmstOrtBaseVo.custype
                }
                if (this.DrtModel && this.DrtModel.decmstDrtBaseVo.custype) {
                body.declare.cusType = this.DrtModel.decmstDrtBaseVo.custype
                }
            } else if (this.declareParams.txCode == '040201' || this.declareParams.txCode == '040203') {
                if (this.OinModel && this.model.declareMod.safeDeclType == 'DecmstOin') {
                body.declare.decmstOinVo = {
                    decmstOinBaseVo: this.OinModel.decmstOinBaseVo,
                    decdtlOinDeclrVo: this.OinModel.decdtlOinDeclrVo,
                }
                }
                if (this.DinModel && this.model.declareMod.safeDeclType == 'DecmstDin') {
                body.declare.decmstDinVo = {
                    decmstDinBaseVo: this.DinModel.decmstDinBaseVo,
                    decdtlDinManageVo: this.DinModel.decdtlDinManageVo,
                }
                }
                if (this.IncomeModel && this.model.declareMod.rcpmisDeclWay == '1') {
                body.declare.decmstIncomeVo = this.IncomeModel
                }
                if (this.OinModel && this.OinModel.decmstOinBaseVo.custype) {
                body.declare.cusType = this.OinModel.decmstOinBaseVo.custype
                }
                if (this.DinModel && this.DinModel.decmstDinBaseVo.custype) {
                body.declare.cusType = this.DinModel.decmstDinBaseVo.custype
                }
            } else if (this.declareParams.txCode == '030301') {
                if (this.ExtguarsModel && this.model.declareMod.safeDeclType[0] == 'DecmstExtGuarSign') {
                body.declare.decmstExtGuarsDTO = {
                    decmstExtGuarSignVo: this.ExtguarsModel,
                    bfcys: this.ExtguarsModel.bfcys,
                    gueds: this.ExtguarsModel.gueds,
                    cgs: this.ExtguarsModel.cgs
                }
                }
                if (this.ExtguarbModel && this.model.declareMod.safeDeclType[1] == 'DecdtlExtGuarBal') {
                body.declare.decdtlExtGuarBalVo = this.ExtguarsModel
                }
                if (this.GuaenrInfoModel && this.model.declareMod.rcpmisDeclWay == '1') {
                body.declare.decmstGuaenrInfoVo = this.GuaenrInfoModel
                }
            } else if (this.declareParams.txCode == '020314') {
                if (this.OpyModel && this.model.declareMod.safeDeclType == 'DecmstOpy') {
                body.declare.decmstOpyVo = {
                    decmstOpyBaseVo: this.OpyModel.decmstOpyBaseVo,
                    decdtlOpyDeclrVo: this.OpyModel.decdtlOpyDeclrVo,
                    decdtlOpyManageVo: this.OpyModel.decdtlOpyManageVo
                }
                }
                if (this.DpyModel && this.model.declareMod.safeDeclType == 'DecmstDpy') {
                body.declare.decmstOpyVo = {
                    decmstDpyBaseVo: this.DpyModel.decmstDpyBaseVo,
                    decdtlDpyManageVo: this.DpyModel.decdtlDpyManageVo,
                }
                }
                if (this.ExpnModel && this.model.declareMod.rcpmisDeclWay == '1') {
                body.declare.decmstExpnVo = this.ExpnModel
                }
            } else if (this.declareParams.txCode == '050205') {
                if (this.OinModel && this.model.declareMod.safeDeclType == 'DecmstOin') {
                body.declare.decmstOinVo = {
                    decmstOinBaseVo: this.OinModel.decmstOinBaseVo,
                    decdtlOinDeclrVo: this.OinModel.decdtlOinDeclrVo,
                }
                }
                if (this.DinModel && this.model.declareMod.safeDeclType == 'DecmstDin') {
                body.declare.decmstDinVo = {
                    decmstDinBaseVo: this.DinModel.decmstDinBaseVo,
                    decdtlDinManageVo: this.DinModel.decdtlDinManageVo,
                }
                }
                if (this.IncomeModel && this.model.declareMod.rcpmisDeclWay == '1') {
                body.declare.decmstIncomeVo = this.IncomeModel
                }
                if (this.OinModel && this.OinModel.decmstOinBaseVo.custype) {
                body.declare.cusType = this.OinModel.decmstOinBaseVo.custype
                }
                if (this.DinModel && this.DinModel.decmstDinBaseVo.custype) {
                body.declare.cusType = this.DinModel.decmstDinBaseVo.custype
                }
            } else if (this.declareParams.txCode == '050105') {
                if (this.OpyModel && this.model.declareMod.safeDeclType == 'DecmstOpy') {
                body.declare.decmstOpyVo = {
                    decmstOpyBaseVo: this.OpyModel.decmstOpyBaseVo,
                    decdtlOpyDeclrVo: this.OpyModel.decdtlOpyDeclrVo,
                    decdtlOpyManageVo: this.OpyModel.decdtlOpyManageVo
                }
                }
                if (this.DpyModel && this.model.declareMod.safeDeclType == 'DecmstDpy') {
                body.declare.decmstOpyVo = {
                    decmstDpyBaseVo: this.DpyModel.decmstDpyBaseVo,
                    decdtlDpyManageVo: this.DpyModel.decdtlDpyManageVo,
                }
                }
                if (this.ExpnModel && this.model.declareMod.rcpmisDeclWay == '1') {
                body.declare.decmstExpnVo = this.ExpnModel
                }
            }else if (this.declareParams.txCode == '020412') {
                //出口信用证收汇
                if (this.OinModel && this.model.declareMod.safeDeclType == 'DecmstOin') {
                body.declare.decmstOinVo = {
                    decmstOinBaseVo: this.OinModel.decmstOinBaseVo,
                    decdtlOinDeclrVo: this.OinModel.decdtlOinDeclrVo,
                }
                }
                if (this.DinModel && this.model.declareMod.safeDeclType == 'DecmstDin') {
                body.declare.decmstDinVo = {
                    decmstDinBaseVo: this.DinModel.decmstDinBaseVo,
                    decdtlDinManageVo: this.DinModel.decdtlDinManageVo,
                }
                }
                if (this.IncomeModel && this.model.declareMod.rcpmisDeclType == '1') {
                body.declare.decmstIncomeVo = this.IncomeModel
                }
                if (this.OinModel && this.OinModel.decmstOinBaseVo.custype) {
                body.declare.cusType = this.OinModel.decmstOinBaseVo.custype
                }
                if (this.DinModel && this.DinModel.decmstDinBaseVo.custype) {
                body.declare.cusType = this.DinModel.decmstDinBaseVo.custype
                }
            }else if (this.declareParams.txCode == '050201') {
                if (this.BankDocSetModel && this.model.declareMod.rcpmisDeclWay == '1') {
                body.declare.decmstbankdocsetVo = this.BankDocSetModel
                }
            }else if (this.declareParams.txCode == '050101') {
                if (this.BankDocSetModel && this.model.declareMod.rcpmisDeclWay == '1') {
                body.declare.decmstbankdocsetVo = this.BankDocSetModel
                }
            }
        
        },

        updateChangeDeclare() {
            let flag = false
              //此时申报model随之变化，若涉及申报字段改动，则会比较出结果
              if (this.compareOrtChanges() == true || this.compareDrtChanges() == true) {
                flag = true
              }
              return flag
        },
      
        compareOrtChanges(){
            var ortChange = [];
            if(this.delcareOldModel.decmstOrtVo){
            ortChange = Utils.compareChanges(this.delcareOldModel.decmstOrtVo, this.OrtModel)
            if(ortChange.length == 0){
                return false 
            }
            return true
            }
            return false
            
        },
    
        compareDrtChanges() {
            var drtChange = [];
            if(this.delcareOldModel.decmstDrtVo){
                drtChange = Utils.compareChanges(this.delcareOldModel.decmstDrtVo, this.DrtModel)
                if(drtChange.length == 0){
                    return false 
                }
                return true
            }
            return false      
        },

        assignDeclareModel(params){
            if(this.delcareOldModel.decmstOrtVo && params.body.declare.decmstOrtVo){
                Object.assign(params.body.declare.decmstOrtVo.decmstOrtBaseVo,this.delcareOldModel.decmstOrtVo.decmstOrtBaseVo);
                Object.assign(params.body.declare.decmstOrtVo.decdtlOrtDeclrVo,this.delcareOldModel.decmstOrtVo.decdtlOrtDeclrVo);
                Object.assign(params.body.declare.decmstOrtVo.decdtlOrtManageVo,this.delcareOldModel.decmstOrtVo.decdtlOrtManageVo);
              }
              if(this.delcareOldModel.decmstDrtVo && params.body.declare.decmstDrtVo){
                Object.assign(params.body.declare.decmstDrtVo.decmstDrtBaseVo,this.delcareOldModel.decmstDrtVo.decmstDrtBaseVo);
                Object.assign(params.body.declare.decmstDrtVo.decdtlDrtManageVo,this.delcareOldModel.decmstDrtVo.decdtlDrtManageVo);
              }
              if(this.delcareOldModel.decmstExpnVo && params.body.declare.decmstExpnVo){
                Object.assign(params.body.declare.decmstExpnVo, this.delcareOldModel.decmstExpnVo);
              }
        }

    },
}