
/**
* Trnrel Check规则
*/
export default {

    "trn.inr"                      :[checkTrnInrN1500,],
    "atpget.sdamod.dadsnd"                      :[checkAtpgetSdamodDadsndN100,],
    "trn.inftxt"                      :[checkTrnInftxtN100,],
    "recpan.atpget.sdamod.dadsnd"                      :[checkRecpanAtpgetSdamodDadsndN100,],
    "recpan.recget.sdamod.dadsnd"                      :[checkRecpanRecgetSdamodDadsndN100,],
}
/**
*   source:trnget.@0009.script
*   recpan.recget
*/
function checkTrnInrN1500()
{
    
  // checkrule to finally check whether contents in the keyfield has been resolved.
  if( ! Utils.isEmpty( model.trn.inr ) && Utils.len( model.trn.inr ) < 8 && Utils.isEmpty( model.dissel ) )
  {
    Utils.error( model.trn.inr, "#CT000003" );
  }


}
/**
*   source:atpget.@0001.script
*   atpget
*/
function checkAtpgetSdamodDadsndN100()
{
    
  //! check whether take is allowed on Drag&Drop sender
  if( Utils.isEmpty( model.atp.inr ) )
  {
    Utils.errorMessage( "#CT000001" );
  }


}
/**
*   source:txmmod.@0009.script
*   recpan.inftxt
*/
function checkTrnInftxtN100()
{
    
  //! Set error, if block contains an Asterisk and is enabled
  //! ZL add for swift standards relese 2018
  //占位符“*”给为占位符“~”
  //add tby
  // `if IsEnabled( TXMBLOCK ) then ` does not work with TRADE2 yet. Thus use the following line instead:
  if( Utils.IsEnabled( Utils.getField( Utils.getAttributeText( model.txmblock, tdAttrFullName ) ) ) )
  {
    Utils.errorAsterisk( model.txmblock );
  }


}
/**
*   source:atpget.@0001.script
*   recpan.atpget
*/
function checkRecpanAtpgetSdamodDadsndN100()
{
    
  //! check whether take is allowed on Drag&Drop sender
  if( Utils.isEmpty( model.atp.inr ) )
  {
    Utils.errorMessage( "#CT000001" );
  }


}
/**
*   source:trnget.@0001.script
*   recpan.recget
*/
function checkRecpanRecgetSdamodDadsndN100()
{
    
  //! check whether take is allowed on Drag&Drop sender
  if( Utils.isEmpty( model.trn.inr ) )
  {
    Utils.errorMessage( "#CT000001" );
  }


}
